function s=atan2(a,b)
%abs: performs atan2(a,b) in qd-data type
if isa(a,'qd')
    p1=getp1(a);p2=getp2(a);p3=getp3(a);p4=getp4(a);
else
    p1=a;p2=zeros(size(a));p3=p2;p4=p2;
end
if isa(b,'qd')
    P1=getp1(b);P2=getp2(b);P3=getp3(b);P4=getp4(b);
else
    P1=b;P2=zeros(size(b));P3=P2;P4=P2;
end
if isreal(p1) & isreal(p2) & isreal(p3) & isreal(p4) & isreal(P1) & isreal(P2) & isreal(P3) & isreal(P4)
  %standard case
  [out1,out2,out3,out4]=qd_atan2(p1,p2,p3,p4,P1,P2,P3,P4);
  %renormalization is not needed because it is already done in the C library
  s.p1=out1;s.p2=out2;s.p3=out3;s.p4=out4;
  s=class(s,'qd');
else
   %complex case
%    realp1=real(p1);realp2=real(p2);
%    imagp1=imag(p1);imagp2=imag(p2);
   error('atan2 not yet implemented for complex variable')
end
