function [V,D]=eig2(A,B,param)
%find eigenvalues and eigenvectors with the power method using the matlab's builtin as a first guess

if ~isa(A,'qd'),A=qd(A);end
%deal with cases where the second parameter might be a qd or not
if (nargin>2) & ~ischar(B)
    %Don't know how the eig(A,B) is defined. Simply provide back the matlab estimate
    switch nargin
        case 2
            if isa(B,'qd')
                [V,D]=eig(getp1(A),getp1(B));
            else
                [V,D]=eig(getp1(A),B);
            end
            return
        case 3
            if isa(B,'qd')
                [V,D]=eig(getp1(A),getp1(B),param);
            else
                [V,D]=eig(getp1(A),B,param);
            end
            return
        otherwise
            error('Wrong number of parameters in eig')
            return
    end
end
%gather intial estimate values. 
if nargin==2
    [V,D]=eig(getp1(A),B);
else
    [V,D]=eig(getp1(A));
end
%iterate to improve the values
D=qd(diag(D));V=qd(V);
for i=1:length(D)
    guessD=2*D(i);guessV=V(:,i);sigma=D(i);iter=0;
    disp(num2str(i))
    while abs((guessD-sigma)/(guessD+sigma))<2^90 & iter<100
        t=A*guessV;guessD=sigma;
        sigma=guessV'*t;
        guessV=t/norm(t);
        iter=iter+1;
    end
    D(i)=sigma;V(:,i)=guessV;
end
D=diag(D);
