function [c,I]=max(a,b,N)
%max: find maximum elements of the first matrix/vector, of qd-type

%find maximum elements of the first matrix/vector, of class qd, producing another element of class qd
%second parameter, if present, deals with the non-singleton (?) dimension. It is definitely not a matrix
if ~isa(a,'qd'),a=qd(a);end
L=double(size(a));
switch nargin
    case 1
        N=1;
        if (min(L)==1) & (L(1)==1)
            %a is a row vector; transpose to find a solution. This should be done 
            %this way instead of the familiar a=a(:) because such operation is not
            %allowed within any file stored under @qd directory
            a=transpose(a);
        end
        if min(L)==1
            %if it is a pure row or column vector, a scalar should be given back
            [out1, out2, out3, out4, I] = qd_max(getp1(a),getp2(a),getp3(a),getp4(a),N);
        else
            %standard case; a row vector composed of the min of each column
            [out1, out2, out3, out4, I] = qd_max(getp1(a),getp2(a),getp3(a),getp4(a),N);
        end
    case 2
        %gives back a matrix of the same size of the inputs
        if ~isa(b,'qd'),b=qd(b);end
        if nargout==2
            error('Only one matrix can be provided as an answer in max.m in this case')
        end
        %check sizes; inputs should be either matrix of the same size, or one of them
        %should be a scalar
        mn=size(getp1(a));MN=size(getp1(b));
        if prod(MN)==1
            b=repmat(b,mn);MN=mn;
        end
        if prod(mn)==1
            a=repmat(a,MN);mn=MN;
        end
        if all(mn==MN)
            %invoke the standard EIGHT ARGUMENT function, using the library
            [out1, out2, out3, out4] = qd_max2(getp1(a),getp2(a),getp3(a),getp4(a),...
                getp1(b),getp2(b),getp3(b),getp4(b));
            I=[];
        else
            %error!
            error(['in max.m; matrices should be have the right size' ])
        end
    case 3
        %second argument should be empty
        if ~isa(b,'qd'),b=qd(b);end
        MN=size(getp1(b));
        if prod(MN)==0
            switch N
                case {1,2}
                    [out1, out2, out3, out4, I] = qd_max(getp1(a),getp2(a),getp3(a),getp4(a),N);
                otherwise
                    %error!
                    error(['in max.m; valid N is 1 or 2, and not ' num2str(N)])            
            end
        else
            %error!
            error(['in max.m; matrices should be have the right size' ])            
        end
    otherwise
        error(['in max.m; Number of arguments is wrong'])
    end
    
    %renormalization is not needed because it is already done in the C library
    c.p1=out1;c.p2=out2;c.p3=out3;c.p4=out4;c=class(c,'qd');
