function c=mrdivide(a,b)
%mrdivide:  /   Slash or right matrix divide. "A/B"

%     A/B is the matrix division of B into A, which is roughly the
%     same as A*INV(B) , except it is computed in a different way.
%     More precisely, A/B = (B'\A')'. See MLDIVIDE for details.
%  
%     C = MRDIVIDE(A,B) is called for the syntax 'A / B' when A or B is an
%     object.
%  
%     See also MLDIVIDE, RDIVIDE, LDIVIDE.

if ~isa(a,'qd'),a=qd(a);end
if ~isa(b,'qd'),b=qd(b);end
if prod(size(b))==1 
    %b is a scalar; use rdivide instead
    c=rdivide(a,b);
else
    c=mldivide(transpose(b),transpose(a));
    c=transpose(c);
end
