function c=pow2(b,E)
%pow2: for one argument, find elementwise powers of base 2 and exponent of class qd "2^b"
%      for two arguments, find elementwise values of "b.*(2.^E)"  

a=repmat(qd(2),size(b));
if ~isa(b,'qd')
    b=qd(b);
end

if nargin==1
    %invoke the standard function, using the library
    [out1, out2, out3, out4] = qd_power(getp1(a),getp2(a),getp3(a),getp4(a),getp1(b),getp2(b),getp3(b),getp4(b));
    
    %renormalization is not needed because it is already done in the C library
    s.p1=out1;s.p2=out2;s.p3=out3;s.p4=out4;c=class(s,'qd');
else
    if ~isa(E,'qd')
        E=qd(E);
    end    
    %invoke the standard function, using the library
    [out1, out2, out3, out4] = qd_power(getp1(a),getp2(a),getp3(a),getp4(a),getp1(E),getp2(E),getp3(E),getp4(E));
    
    %renormalization is not needed because it is already done in the C library
    s.p1=out1;s.p2=out2;s.p3=out3;s.p4=out4;c=class(s,'qd');
    c=b.*c;
end
