function c=power(a,b)
%power: find elementwise powers of two matrices of class qd "a.^b"

%find elementwise powers of two matrices of class qd, producing another element of class qd
%one of them might be scalar; otherwise, they should have the same size
if ~isa(a,'qd')
    a=qd(a);
end
if ~isa(b,'qd')
    b=qd(b);
end
hi1=getp1(a);hi2=getp1(b);
%check for dimensions
if size(hi1,1)~=size(hi2,1) | size(hi1,2)~=size(hi2,2)
    %they have different sizes, which might be an error except if one matrix is a scalar one
    if prod(size(hi1))==1 | prod(size(hi2))==1
        %one is scalar; do not check for dimensions
        if prod(size(hi1))==1 
            %first element is scalar; reshape it to be of the same size of the second term
            s.p1=repmat(getp1(a),size(hi2));
            s.p2=repmat(getp2(a),size(hi2));
            s.p3=repmat(getp3(a),size(hi2));
            s.p4=repmat(getp4(a),size(hi2));
            a=class(s,'qd');
        else
            %second element is scalar; reshape it to be of the same size of the first term
            s.p1=repmat(getp1(b),size(hi1));
            s.p2=repmat(getp2(b),size(hi1));
            s.p3=repmat(getp3(b),size(hi1));
            s.p4=repmat(getp4(b),size(hi1));
            b=class(s,'qd');
        end
    else
        %error!
        error(['in power.m; matrices should be have the right size' ])
    end
end
%invoke the standard function, using the library
[out1, out2, out3, out4] = qd_power(getp1(a),getp2(a),getp3(a),getp4(a),getp1(b),getp2(b),getp3(b),getp4(b));
    
%renormalization is not needed because it is already done in the C library
s.p1=out1;s.p2=out2;s.p3=out3;s.p4=out4;c=class(s,'qd');
