 #include <mex.h>
 #include "qd.h"
 #include "qd_inline.h"
 
 
 /*The gateway routine */
 void mexFunction(int nlhs,mxArray *plhs [],	int nrhs,const mxArray *prhs [])
 	{
 	double *inp1, *inp2, *inp3, *inp4;
 	double *sec1, *sec2, *sec3, *sec4;
 	double *out1, *out2, *out3, *out4;
 	int status,mrows,ncols,mrows2,ncols2;
 
 	/*Check for proper number of arguments.*/
 	/*NOTE:You do not need an else statement when using
 	mexErrMsgTxt within an if statement.It will never
 	get to the else statement if mexErrMsgTxt is executed.
 	(mexErrMsgTxt breaks you out of the MEX-file.)
 	*/
 	if (nrhs !=8)
 		mexErrMsgTxt("Eight inputs required.");
 	if (nlhs !=4)
 		mexErrMsgTxt("Four output required.");
 
 
 	if (!mxIsDouble(prhs [0 ]) || mxIsComplex(prhs [0 ]) || !mxIsDouble(prhs [1 ]) || mxIsComplex(prhs [1 ]) ){
 		mexErrMsgTxt("Input matrix type should be ok.");
 	}
 
	if (mxGetN(prhs [0 ]) != mxGetM(prhs [4 ])){
 		mexErrMsgTxt("Matrix size is not correct.");
 	}

 	/*Get the dimensions of the first matrix input.*/
 	mrows =mxGetM(prhs [0 ]);
 	ncols =mxGetN(prhs [0 ]);

 	/*Get the dimensions of the fifth matrix input.*/
 	mrows2 =mxGetM(prhs [4 ]);
 	ncols2 =mxGetN(prhs [4 ]);
		
	/*Create a pointer to the input matrices.*/
 	inp1 =mxGetPr(prhs [0 ]);
 	inp2 =mxGetPr(prhs [1 ]);
 	inp3 =mxGetPr(prhs [2 ]);
 	inp4 =mxGetPr(prhs [3 ]);
 	sec1 =mxGetPr(prhs [4 ]);
 	sec2 =mxGetPr(prhs [5 ]);
 	sec3 =mxGetPr(prhs [6 ]);
 	sec4 =mxGetPr(prhs [7 ]);
 
 	/*Set the output pointer to the output matrix.*/
 	plhs [0 ] = mxCreateDoubleMatrix(mrows,ncols2,mxREAL);
 	plhs [1 ] = mxCreateDoubleMatrix(mrows,ncols2,mxREAL);
 	plhs [2 ] = mxCreateDoubleMatrix(mrows,ncols2,mxREAL);
 	plhs [3 ] = mxCreateDoubleMatrix(mrows,ncols2,mxREAL);
 
 	/*Create a C pointer to a copy of the output matrix.*/
 	out1 =mxGetPr(plhs [0 ]);
 	out2 =mxGetPr(plhs [1 ]);
 	out3 =mxGetPr(plhs [2 ]);
 	out4 =mxGetPr(plhs [3 ]);

 	/*Call the C subroutine.*/
 
 	int i, j, k;
 	for (i=0; i<mrows; i++) {
 		for ( j=0; j<ncols2; j++) {
            qd_real cumcum(0,0,0,0);
			for ( k=0; k<ncols; k++) {
                /* first index is i+mrows*k, which ranges from obviously 0 to
				(mrows-1)+mrows*(ncols-1) = mrows*ncols-1 right! */
			    qd_real a(inp1[i+mrows*k], inp2[i+mrows*k], inp3[i+mrows*k], inp4[i+mrows*k]);			

				/* second index is k+mrows2*j, which ranges from 0 to
				(ncols-1)+mrows2*(ncols2-1), and since ncols=mrows2
				this is equal to mrows2*ncols2-1, also right! */
    			qd_real b(sec1[k+mrows2*j], sec2[k+mrows2*j], sec3[k+mrows2*j], sec4[k+mrows2*j]);	

				cumcum=cumcum+a*b;
				//mexPrintf("(%d,%d)=%d\n",i,j,a.hi);
			}
			/* this index is i+mrows*j, which ranges from 0 to 
			(mrows-1)+mrows*(ncols2-1) = mrows*ncols2-1, right!*/
			out1[i+mrows*j] = cumcum.x[0];
			out2[i+mrows*j] = cumcum.x[1];
			out3[i+mrows*j] = cumcum.x[2];
			out4[i+mrows*j] = cumcum.x[3];
			//mexPrintf("=====>(%d,%d)=%d\n",i,j,cumcum.hi);
 		}
 	} 
 }
