#include <mex.h>
#include "qd.h"
#include "qd_inline.h"


/*The gateway routine */
void mexFunction(int nlhs,mxArray *plhs [],	int nrhs,const mxArray *prhs [])
	{
	mxLogical *ptrBool;
 	double *inp1, *inp2, *inp3, *inp4;
 	double *sec1, *sec2, *sec3, *sec4;
	int status,mrows,ncols,dummyIntA,dummyIntB;

	/*Check for proper number of arguments.*/
	/*NOTE:You do not need an else statement when using
	mexErrMsgTxt within an if statement.It will never
	get to the else statement if mexErrMsgTxt is executed.
	(mexErrMsgTxt breaks you out of the MEX-file.)
	*/
	if (nrhs !=8)
		mexErrMsgTxt("Eight inputs required.");
	if (nlhs !=1)
		mexErrMsgTxt("Just one output required.");


	if (!mxIsDouble(prhs [0 ]) || mxIsComplex(prhs [0 ]) || !mxIsDouble(prhs [1 ]) || mxIsComplex(prhs [1 ])) {
		mexErrMsgTxt("Input matrix type are not suitable.");
	}

	/*Create a pointer to the input matrices.*/
 	inp1 =mxGetPr(prhs [0 ]);
 	inp2 =mxGetPr(prhs [1 ]);
 	inp3 =mxGetPr(prhs [2 ]);
 	inp4 =mxGetPr(prhs [3 ]);
 	sec1 =mxGetPr(prhs [4 ]);
 	sec2 =mxGetPr(prhs [5 ]);
 	sec3 =mxGetPr(prhs [6 ]);
 	sec4 =mxGetPr(prhs [7 ]);

	/*Get the dimensions of the first matrix input y.*/
	mrows =mxGetM(prhs [0 ]);
	ncols =mxGetN(prhs [0 ]);
	//mexPrintf("%d%s\n",mrows," <==mrows");
	//mexPrintf("%d%s\n",ncols," <==ncols");

	plhs [0 ] = mxCreateLogicalMatrix(mrows,ncols);

	/*Create a C pointer to a copy of the output matrix.*/
	ptrBool = mxGetLogicals(plhs [0 ]);
	//ptrBool = mxGetData(plhs [0 ]);

	/*Call the C subroutine.*/

	int i, j;
	for ( j=0; j<ncols; j++) {
		for (i=0; i<mrows; i++) {
			/* index i+ncols*j ranges from 0 to (mrows-1)+ncols*(ncols-1)*/
			qd_real a(inp1[i+mrows*j], inp2[i+mrows*j], inp3[i+mrows*j], inp4[i+mrows*j]);			
			qd_real b(sec1[i+mrows*j], sec2[i+mrows*j], sec3[i+mrows*j], sec4[i+mrows*j]);	
            qd_real cero(0,0,0,0);
			//check if a is less, equal or larger than b (which is equivalent to -1, 0 , 1)
			//c_qd_comp(&a,&b,&dummyInt);
			if (a < cero)
				dummyIntA = 1;
			else if (a > cero)
				dummyIntA = 1;
			else 
				dummyIntA = 0;

			if (b < cero)
				dummyIntB = 1;
			else if (b > cero)
				dummyIntB = 1;
			else 
				dummyIntB = 0;
			
			//initially is created as false
			if (dummyIntA==1 | dummyIntB==1) {
				*( mxGetLogicals(plhs[0]) + i+mrows*j )=true;
			}
		}
	}
}

