#include <mex.h>
#include "qd.h"
#include "qd_inline.h"


/*The gateway routine */
void mexFunction(int nlhs,mxArray *plhs [],	int nrhs,const mxArray *prhs [])
	{
 	double *inp1, *inp2, *inp3, *inp4;
 	double *sec1, *sec2, *sec3, *sec4;
 	double *out1, *out2, *out3, *out4;
	int status,mrows,ncols;

	/*Check for proper number of arguments.*/
	/*NOTE:You do not need an else statement when using
	mexErrMsgTxt within an if statement.It will never
	get to the else statement if mexErrMsgTxt is executed.
	(mexErrMsgTxt breaks you out of the MEX-file.)
	*/
	if (nrhs !=8)
		mexErrMsgTxt("Eight inputs required.");
	if (nlhs !=4)
		mexErrMsgTxt("Four output required.");


	if (!mxIsDouble(prhs [0 ]) || mxIsComplex(prhs [0 ]) || !mxIsDouble(prhs [1 ]) || mxIsComplex(prhs [1 ])) {
		mexErrMsgTxt("Input matrix type are not suitable.");
	}

	/*Create a pointer to the input matrices.*/
 	inp1 =mxGetPr(prhs [0 ]);
 	inp2 =mxGetPr(prhs [1 ]);
 	inp3 =mxGetPr(prhs [2 ]);
 	inp4 =mxGetPr(prhs [3 ]);
 	sec1 =mxGetPr(prhs [4 ]);
 	sec2 =mxGetPr(prhs [5 ]);
 	sec3 =mxGetPr(prhs [6 ]);
 	sec4 =mxGetPr(prhs [7 ]);

	/*Get the dimensions of the first matrix input y.*/
	mrows =mxGetM(prhs [0 ]);
	ncols =mxGetN(prhs [0 ]);
	//mexPrintf("%d%s\n",mrows," <==mrows");
	//mexPrintf("%d%s\n",ncols," <==ncols");

	/*leading dimension; should be 1 */
/*	mrows =mxGetM(prhs [2 ]);
	ncols =mxGetN(prhs [2 ]);
	mexPrintf("%d%s\n",mrows," <==mrows");
	mexPrintf("%d%s\n",ncols," <==ncols");*/

	/*Set the output pointer to the output matrix.*/
	int nout;
	nout=ncols;
	//if (mrows=1 | ncols=1), nout=1;

	plhs [0 ] = mxCreateDoubleMatrix(1,nout,mxREAL);
	plhs [1 ] = mxCreateDoubleMatrix(1,nout,mxREAL);
	plhs [2 ] = mxCreateDoubleMatrix(1,nout,mxREAL);
	plhs [3 ] = mxCreateDoubleMatrix(1,nout,mxREAL);
 
 	/*Create a C pointer to a copy of the output matrix.*/
 	out1 =mxGetPr(plhs [0 ]);
 	out2 =mxGetPr(plhs [1 ]);
 	out3 =mxGetPr(plhs [2 ]);
 	out4 =mxGetPr(plhs [3 ]);

	/*Call the C subroutine.*/

	int i, j;
	for ( j=0; j<ncols; j++) {
		qd_real cum(1,0,0,0);	
		for (i=0; i<mrows; i++) {
			/* index i+ncols*j ranges from 0 to (mrows-1)+ncols*(ncols-1)*/
			qd_real a(inp1[i+mrows*j], inp2[i+mrows*j], inp3[i+mrows*j], inp4[i+mrows*j]);			
			qd_real b(sec1[i+mrows*j], sec2[i+mrows*j], sec3[i+mrows*j], sec4[i+mrows*j]);	
			//mexPrintf("%d\n",i+mrows*j);
			cum=cum*a;
		}
		out1[j] = cum.x[0];
		out2[j] = cum.x[1];
		out3[j] = cum.x[2];
		out4[j] = cum.x[3];
	}
	
}

