function [Q,R,E]=qr(A,flag)
%qr: orthogonal-triangular decomposition
E=[];
if isempty(A),Q=qd([]);R=Q;E=Q;return;end
if nargout>2,error(['QR unimplemented for this case']);end
if nargin<2,flag=1;end
[Q,R]=myqr(A,flag); 


return
if isempty(A),Q=dd([]);R=Q;E=Q;return;end
if nargin==1,flag=1;end
if all(all(getlo(A)==0))
    %use the builtin
    if nargout==3 
        if flag~=0
            [Q,R,E]=qr(gethi(A),flag);
            Q=dd(Q);R=dd(R);E=dd(E);
        else
            error('with economy size only two outputs are allowed')
        end
    else
        if flag==0
            [Q,R]=qr(gethi(A),0);
        else
            [Q,R]=qr(gethi(A));
        end        
        Q=dd(Q);R=dd(R);
    end
else
    [Qhi,Qlo,Rhi,Rlo]=dd_qr(gethi(A),getlo(A),flag);
    %need not to renormalize; it is done through the C++ library
    Q.hi=Qhi;Q.lo=Qlo;Q=class(Q,'dd');
    R.hi=Rhi;R.lo=Rlo;R=class(R,'dd');
    if nargout==3,
        disp('qr: three output case unimplemented yet!');
        E=dd_eye(size(A,2));
    end
end