function c=rdivide(a,b)
%rdivide: divides elementwise two matrices of class qd, producing another element of class qd "a./b"
if ~isa(a,'qd')
    a=qd(a);
end
if ~isa(b,'qd')
    b=qd(b);
end
hi1=getp1(a);hi2=getp1(b);
%check for dimensions
if any(size(hi1)~=size(hi2))
    %they have different sizes, which might be an error except if one matrix is a scalar one
    if prod(size(hi1))==1 | prod(size(hi2))==1
        %one is scalar; do not check for dimensions
        if prod(size(hi1))==1 
            %first element is scalar; reshape it to be of the same size of the second term
            a=qd(repmat(getp1(a),size(hi2)),repmat(getp2(a),size(hi2)),repmat(getp3(a),size(hi2)),repmat(getp4(a),size(hi2)));
        else
            %second element is scalar; reshape it to be of the same size of the first term
            b=qd(repmat(getp1(b),size(hi1)),repmat(getp2(b),size(hi1)),repmat(getp3(b),size(hi1)),repmat(getp4(b),size(hi1)));
        end
    else
        %error!
        error(['in rdivide.m; matrices should be have the right size' ])
    end
end
%invoke the standard function, using the library
[p1,p2,p3,p4] = qd_rdivide(getp1(a),getp2(a),getp3(a),getp4(a),getp1(b),getp2(b),getp3(b),getp4(b));
%renormalization is not needed because it is already done in the C library
s.p1=p1;s.p2=p2;s.p3=p3;s.p4=p4;c=class(s,'qd');
