function varargout=size(x,N)
%size: extracts dimensions of a qd-type matrix A along singleton N

%attempt #1:
% 		"size" should provide back numbers of type double. However, as a workaround to the lack of
% 		automatic promotion, we will provide qd-type numbers. The reason is that (provided x is of 
% 		qd-type) statements like
%                     H=zeros(size(x));H(1)=x(1);
% 		will not fail with the 
%                     ??? Conversion to double from qd is not possible.
% 		error message. The overloaded version of "zeros" will be called, and thus H will be of type qd.
% 		The same will happend for eye, ones, cell and rand.
% 		
%       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%       Uncomment the following if you want such behavior
%       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% 		s = size(gethi(x));
% 		if nargin==2,s=qd(s(N));end
% 		nout = max(nargout,1);
% 		if nout==1
%             varargout(1)={qd(s)};
% 		else
%             for i=1:nout, varargout(i) = {qd(s(i))}; end
% 		end
%
%attempt #2:
%       apparently the damage is larger than the benefits. So size will produce a double-type answer

s = size(getp1(x));
if nargin==2,s=s(N);end
nout = max(nargout,1);
if nout==1
    varargout(1)={s};
else
    for i=1:nout, varargout(i) = {s(i)}; end
end
