function [c,I]=sort(a,DIM)
%sort: sort in ascending order

if isempty(a),c=[];I=[];return;end
if nargin==2
    %second parameter should be of type double
    DIM=double(DIM);
else
    DIM=1;%default value
end
if nargin==1
    if min(size(a))==1%deal with either row or column vectors as rows
        P1=getp1(a);P2=getp2(a);P3=getp3(a);P4=getp4(a);
        if size(a,1)==1 %row vector
            [c,I]=sortrows([P1' P2' P3' P4'],[1 2 3 4]);I=I';        
            %send back a true qd-value
            %original c=a(I,:); %does not work due to a bug somewhere in matlab
            %the workaround: invoke directly the subsref routine
            SS.type='()';SS.subs={':' I};c=subsref(a,SS);
        else
            [c,I]=sortrows([P1 P2 P3 P4],[1 2 3 4]);     
            %same as before
            SS.type='()';SS.subs={I ':'};c=subsref(a,SS);
        end
    else
        %do the same for each column
        SS.type='()';SS.subs={':' 1};
        [c,I]=sort(subsref(a,SS));        
        for k=2:size(a,2)
            SS.subs={':' k};
            [dummy,I(:,k)]=sort(subsref(a,SS));
            c=subsasgn(c,SS,dummy);
        end
    end
else
    %we only deal with two-dimensional objects, so let's consider both cases
    %and disregard the others
    switch DIM
        case 1
            %standard order; call the routine without the DIM parameter
            [c,I]=sort(a);
        case 2
            %call the routine with the transpose
            [c,I]=sort(a');
            %and transpose the answer
            c=c';
        otherwise
            error(['unsupported option; we recognize only DIM=1 or 2, not ' num2str(DIM)]) 
    end
end
