function C=subsasgn(A,S,B)
%subsasgn    A = SUBSASGN(A,S,B) is called for the syntax A(I)=B, A{I}=B when A is of qd-type

%    A = SUBSASGN(A,S,B) is called for the syntax A(I)=B, A{I}=B, or
%     A.I=B when A is an object.  S is a structure array with the fields:
%         type -- string containing '()', '{}', or '.' specifying the
%                 subscript type.
%         subs -- Cell array or string containing the actual subscripts.
%  
%     For instance, the syntax A(1:2,:)=B calls A=SUBSASGN(A,S,B) where
%     S is a 1-by-1 structure with S.type='()' and S.subs = {1:2,':'}. A
%     colon used as a subscript is passed as the string ':'.
%  
%     Similarly, the syntax A{1:2}=B invokes A=SUBSASGN(A,S,B) where
%     S.type='{}' and the syntax A.field=B invokes SUBSASGN(A,S,B) where
%     S.type='.' and S.subs='field'.

%disp 'subsasgn overloaded at @qd!'
if ~isa(A,'qd'),A=qd(A);end
if ~isa(B,'qd'),B=qd(B);end
C.p1=subsasgn(getp1(A),S,getp1(B));
C.p2=subsasgn(getp2(A),S,getp2(B));
C.p3=subsasgn(getp3(A),S,getp3(B));
C.p4=subsasgn(getp4(A),S,getp4(B));
C=class(C,'qd');%needs not to renormalize

