function I=subsindex(A)
%subsindex: Subscript index for qd-type matrix

% SUBSINDEX Subscript index.
%     I = SUBSINDEX(A) is called for the syntax 'X(A)' when A is an
%     object and X is one of the built-in types (most commonly
%     'double').  SUBSINDEX must return the value of the object as a
%     zero-based integer index (I must contain integer values in the
%     range 0 to prod(size(X))-1).  SUBSINDEX is called by the default
%     SUBSREF and SUBSASGN functions and you may call it yourself if you
%     overload these functions.
%  
%     SUBSINDEX is invoked separately on all the subscripts in an
%     expression such as X(A,B). 

%I=builtin('subsindex',double(A));
I=double(A)-1; %suggested by Ben Barrowes