function B=subsref(A,S)
%subsref: B = SUBSREF(A,S) is called for the syntax A(I), A{I}, or A.I for A of qd-type

%    B = SUBSREF(A,S) is called for the syntax A(I), A{I}, or A.I
%     when A is an object.  S is a structure array with the fields:
%         type -- string containing '()', '{}', or '.' specifying the
%                 subscript type.
%         subs -- Cell array or string containing the actual subscripts.
%  
%     For instance, the syntax A(1:2,:) invokes SUBSREF(A,S) where S is a
%     1-by-1 structure with S.type='()' and S.subs = {1:2,':'}. A colon
%     used as a subscript is passed as the string ':'.
%  
%     Similarly, the syntax A{1:2} invokes SUBSREF(A,S) where S.type='{}'
%     and the syntax A.field invokes SUBSREF(A,S) where S.type='.' and
%     S.subs='field'.

%disp('subsref of type qd has been overloaded!')
%this should never happend, but...
if ~isa(A,'qd'),A=qd(A);end
B.p1=subsref(getp1(A),S);
B.p2=subsref(getp2(A),S);
B.p3=subsref(getp3(A),S);
B.p4=subsref(getp4(A),S);
B=class(B,'qd');

