function c=sum(a,N)
%sum: adds elements of the first matrix/vector, of class qd, producing another element of class qd

if isempty(a)
    c=a;%which is indeed empty!
    return
end
%second parameter, if present, deals with the non-singleton (?) dimension. It is definitely not a matrix
if ~isa(a,'qd')
    a=qd(a);
end
%default is to sum by columns
if nargin<2,N=1;end

%second argument should be a scalar; however, convert it to a double-type just in case
N=double(N);

%check dimensions; N should be a scalar
if prod(size(N)) == 1
    L=double(size(a));
    if min(L)==1
        %vector case
        [dummy N]=max(L);
        [out1, out2, out3, out4] = qd_sum(getp1(a(:)),getp2(a(:)),getp3(a(:)),getp4(a(:)),N);
    else
        %invoke the standard function, using the library
        [out1, out2, out3, out4] = qd_sum(getp1(a),getp2(a),getp3(a),getp4(a),N);
    end
    %renormalization is not needed because it is already done in the C library
    s.p1=out1;s.p2=out2;s.p3=out3;s.p4=out4;
    c=class(s,'qd');
else
    %error!
    error(['in sum.m; matrices should be have the right size' ])
end
