%Script for automatic recompilation of the necessary files for the class qd
%If you wish so, use it as a template for new classes 
%It assumes that the cpp files have already been created, and stored in the local directory

%By CLV, dec 2004

%it presumes that the constructror class qd is already available, and stored 
%in the proper directory
outdir=which('qd');outdir=outdir(1:(length(outdir)-9));
PWD=pwd;cd(outdir)
%build simple functions dependent on just one argument of type qd
unaryList={'abs' 'acosh' 'asinh' 'atan' 'atanh'  ...
        'ceil' 'cos' 'cosh' ...
        'sin' 'sinh' 'tan' 'tanh' };
T=1;
for i=T:length(unaryList)
    %create matlab and cpp source code
    txt=char(unaryList{i});
    txtout=unary_qd(txt);
    disp(txt)
    %compile it, and store the output in the private directory below @qd
    eval(['mex -outdir .\@qd\private\ -I.\src_qd\include qd_' txt '.cpp src_qd\c_qd.cpp src_qd\qd.cpp src_qd\bits.cpp src_qd\x86.cpp .\include_qd\qd_const.cpp']);
end
%some trivial ones; first those obviously false
trivial={ 'islogical' 'ischar'};
for i=1:length(trivial)
    a=char(trivial{i});
    fid=fopen(['@qd\' a '.m'],'w');
    fprintf(fid,'%s\n',['function s=' a '(a)']);
    fprintf(fid,['%' a ' always false for qd-type matrix']);
    fprintf(fid,'%s\n','s=false(1);');
    fclose(fid);
end
trivial={'isnumeric' 'isfloat'};
for i=1:length(trivial)
    a=char(trivial{i});
    fid=fopen(['@qd\' a '.m'],'w');
    fprintf(fid,'%s\n',['function s=' a '(a)']);
    fprintf(fid,['%' a ' always true for qd-type matrix']);
    fprintf(fid,'%s\n','s=true(1);');
    fclose(fid);
end
return
%the other functions are not so straightforward to create
manuallyCreated={'sqrt' 'acos' 'asin' 'exp' 'log' 'all' 'and' 'any' ...
        'eq' 'ge' 'gt' 'le' 'lt' 'ne' 'not' 'or' 'xor'...
        'max' 'max2' 'min' 'min2' 'minus' 'find'  ...
        'nnz' 'plus' 'power' 'prod' 'rdivide' 'round' 'sign' ...
        'mtimes' 'mul' 'floor' 'ceil' 'atan2' 'sum' 'times' 'write'};
T=1;
for i=T:length(manuallyCreated)
    txt=char(manuallyCreated{i});
    eval(['disp(' setstr(39) txt setstr(39) ');mex -outdir .\@qd\private\ -Isrc_qd\include qd_' txt '.cpp src_qd\c_qd.cpp src_qd\qd.cpp src_qd\bits.cpp src_qd\x86.cpp include_qd\qd_const.cpp']);
end

%implemented within matlab 'fix' 'rem', 'log10'

%implemented for class dd, but not for qd: 'qr' 'chol' 

%still unimplemented, ill-implemented or alike
unaryListDifficult={'det' ...
        'eig' 'expm' 'filter' 'ndims' 'randn' 'rand' 'sort' ...
        'inv' 'schur' 'sparse' 'svd'}

%for automatic compilation of all *.cpp
% d=dir('*.cpp');
% for i=1:length(d)
%     txt=d(i).name;disp(txt)
%     eval(['mex -outdir .\@qd\private -Iinclude ' txt ' src_qd\c_qd.cpp src_qd\qd.cpp src_qd\bits.cpp src_qd\x86.cpp include\qd\qd_const.cpp']);
% end
cd(PWD)