%test_qd: quick and dirty tests for class qd
%0) chech that it is working without extended precision
%Test provided by Yozo, yozo@cs.berkeley.edu
A = [ builtin('ones',100, 1), 2.^-(1:100)', builtin('ones',100, 1), builtin('zeros', 100, 5)];
b = [1 1 -1 1 1 1 1 1]';
N=sum(A*b == 0);
if (N==48),disp('Test 0 passed'),else, disp('Test 0 failed'),end

eps=builtin('eps');   
a42=((qd(builtin('rand',4,2))+builtin('rand',4,2)*eps)+builtin('rand',4,2)*eps)+builtin('rand',4,2)*eps;
%1) check that it is a normalized value
a=getp1(a42);b=getp2(a42);c=getp3(a42);d=getp4(a42);
if ~all(all((a+b+c+d)==a)),disp('Test 1 failed'),else,disp('Test 1 passed'),end

%2) direct/inverse pairs
c_qd=norm(asin(sin(a42))-a42);disp(['2.1 sin/asin' setstr(9) num2str(c_qd)])
c_qd=norm(acos(cos(a42))-a42);disp(['2.2 cos/acos' setstr(9) num2str(c_qd)])
c_qd=norm(atan(tan(a42))-a42);disp(['2.3 tan/atan' setstr(9) num2str(c_qd)])
c_qd=norm(asinh(sinh(a42))-a42);disp(['2.4 sinh/asinh' setstr(9) num2str(c_qd)])
c_qd=norm(acosh(cosh(a42))-a42);disp(['2.5 cosh/acosh' setstr(9) num2str(c_qd)])
c_qd=norm(atanh(tanh(a42))-a42);disp(['2.6 tanh/atanh' setstr(9) num2str(c_qd)])
c_qd=norm(exp(log(a42))-a42);disp(   ['2.7 exp/log   ' setstr(9) num2str(c_qd)])
c_qd=norm(sqrt(a42.^2)-a42); disp(    ['2.8 sqrt/^2   ' setstr(9) num2str(c_qd)])
c_qd=norm((sin(a42).^2+cos(a42).^2-1));disp(['2.1 sin^2+cos2^2-1' setstr(9) num2str(c_qd)])


minmaxlog=[1 1];
minmaxtan=[1 1];
minmaxtanh=[1 1];
for i=1:1021
    t=1+qd(pow2(1,-i));
    h=exp(log(t))/t;%should be 1.0 always
    minmaxlog=[min(minmaxlog(1),h) max(minmaxlog(2),h)];
    h=atan(tan(t))/t;%should be 1.0 always
    minmaxtan=[min(minmaxtan(1),h) max(minmaxtan(2),h)];
    h=atanh(tanh(t))/t;%should be 1.0 always
    minmaxtanh=[min(minmaxtanh(1),h) max(minmaxtanh(2),h)];
end
minmaxlog,minmaxtan,minmaxtanh

%3) Taylor expansion's
a42=a42(:);
disp(['3.: The following ratio should be very close to 1.0, for varying i'])
for i=180:5:210
    t=2^-i;
    c=((exp(a42+t)-exp(a42))/t)./exp(a42);
    disp([repmat([num2str(-i) setstr(9)],size(c(:,1)),1) num2str(getp1(c))])
end
a42=reshape(a42,4,2);

%4) Catastrophic cancellation 
z=sqrt(117)-sqrt(116);zExact=1/(sqrt(117)+sqrt(116));
zqd=sqrt(qd(117))-sqrt(qd(116));zqdExact=1/(sqrt(qd(117))+sqrt(qd(116)));
disp('4.1 Improvement in the catastrophic cancellation of sqrt(117)-sqrt(116)')
disp([setstr(9) 'Standard double precision:' num2str(100*abs(z/zExact-1)) ])
disp([setstr(9) 'Quad double precision:    ' num2str(100*abs(double(zqd/zqdExact-1)))])

%5) Test matrix; since we have not coded the eigenvalues, svd, etc. (because it should
%be implemented with complex arithmetic), we will only test that the accuracy 
%of an exact inverse times the matrix is closer to the identity in qd rather than in double
%5.1 Hilbert
n=14;

J = qd(1:n);
J = J(ones(n,1),:);
I = J';
E = ones(n,n);
qdHilb = E./(I+J-qd(1));

%Now the inverse; this is a slightly modified version of invhilb.m to produce qd values
p = n;
H = qd(zeros(n,n));
for k = 1:n
    i=qd(k);
    if k > 1, p = ((n-i+1)*p*(n+i-1))/(qd(k)-1)^2; end
    r = p*p;
    H(k,k) = r/(2*i-1);
    for j = i+1:n
        r = -((n-j+1)*r*(n+j-1))/(qd(j)-1)^2;
        H(k,j) = r/(i+j-1);
        H(j,k) = r/(i+j-1);
    end
end
disp(['5.1 Hilbert matrix and its exact inverse.'])
disp(['    norm in double vs. norm in qd; should be very nearly zero'])
disp(num2str([norm(hilb(n)*invhilb(n)-eye(n)) norm(H*qdHilb-eye(n))]));

X = qd([2 8 4;7 3 9]);   
%min(X,[],1) should be [2 3 4],
if all(min(X,[],1) == [2 3 4]), disp('Test 6.1 passed'), else, disp('Test 6.1 failed'),end
if all(min(X,[],2) == [2;3]), disp('Test 6.2 passed'), else, disp('Test 6.2 failed'),end
if all(min(X,5)==[2 5 4;5 3 5]), disp('Test 6.3 passed'), else, disp('Test 6.3 failed'),end

if all(max(X,[],1)==[7 8 9]), disp('Test 6.4 passed'), else, disp('Test 6.4 failed'),end
if all(max(X,[],2)==[8;9]), disp('Test 6.5 passed'), else, disp('Test 6.5 failed'),end
if all(max(X,5)==[5 8 5;7 5 9]),disp('Test 6.6 passed'), else, disp('Test 6.6 failed'),end

X = qd([0 1 2;3 4 5]);
 
if all(sum(X,1) == [3 5 7]), disp('Test 6.7 passed'), else, disp('Test 6.7 failed'),end
if all(sum(X,2) == [ 3;12]), disp('Test 6.8 passed'), else, disp('Test 6.8 failed'),end
 
X = qd([3 7 5;0 4 2]);
if all(sort(X,1) == [0 4 2;3 7 5] ), disp('Test 6.9 passed'), else, disp('Test 6.9 failed'),end
if all(sort(X,2) == [3 5 7;0 2 4] ), disp('Test 6.10 passed'), else, disp('Test 6.10 failed'),end

%An example taken from "MPL: a multiprecision Matlab-like environment"
%                       Walter Schreppers, Franky Backeljauw, and Annie Cuyt
%                       http://www.walter.schreppers.com/files/mpl.pdf
%Exact value should be -1951/2358 ~ -0.872...
setstr10=builtin('setstr',10);
disp(['Example 1 (by Walter Schreppers):' setstr10 ...
        'a = 77617;b= 33096;' setstr10 ...
        'y = 333.75*b*b*b*b*b*b + ' setstr10 ...
        'a*a * (11*a*a*b*b - b*b*b*b*b*b - 121*b*b*b*b - 2) + ' setstr10 ...
        '5.5*b*b*b*b*b*b*b*b + a/(2*b)']);
disp(['Exact value             :' num2str(-1951/2358,16)])

a = 77617;b= 33096;
ydouble = 333.75*b*b*b*b*b*b + ...
a*a * (11*a*a*b*b - b*b*b*b*b*b - 121*b*b*b*b - 2) + ...
5.5*b*b*b*b*b*b*b*b + a/(2*b); 
disp(['Double precision (wrong):' num2str(ydouble,16)])

%Now with quad-double precision
a = qd(77617);b=qd(33096);
yqd = 333.75*b*b*b*b*b*b + ...
a*a * (11*a*a*b*b - b*b*b*b*b*b - 121*b*b*b*b - 2) + ...
5.5*b*b*b*b*b*b*b*b + a/(2*b);
disp(['Quad precision   (right):' num2str(double(yqd),16)])
