function txt=unary(a)
%creates source code of two types:
% a) cpp source code of the unary operation described by string "a" and stores it
%    in local file ['qd_' a '.cpp']; valid "as is" for real variables
% b) m source code for the same unary operation, but stored in the @qd subdirectory
%    It is valid "as is" for real variables, while specific changes for complex need
%    to be done manually

%by CLV, 20041125

fid=fopen(['@qd\qd_' a '.cpp'],'w');
fprintf(fid,'%s\n',' #include <mex.h>');
fprintf(fid,'%s\n',' #include "qd.h"');
fprintf(fid,'%s\n',' #include "qd_inline.h"');
fprintf(fid,'%s\n',' /*This code has been generated automatically through unary_qd.m. If you plan to make*/');
fprintf(fid,'%s\n',' /*any changes to this source, do them at the abovementioned file*/');
fprintf(fid,'%s\n',' /*The gateway routine */');
fprintf(fid,'%s\n',' void mexFunction(int nlhs,mxArray *plhs [], int nrhs,const mxArray *prhs [])');
fprintf(fid,'%s\n',' 	{');
fprintf(fid,'%s\n',' 	double *inp1, *inp2, *inp3, *inp4;');
fprintf(fid,'%s\n',' 	double *out1, *out2, *out3, *out4;');
fprintf(fid,'%s\n',' 	int status,mrows,ncols;');
fprintf(fid,'%s\n',' ');
fprintf(fid,'%s\n',' 	/*Check for proper number of arguments.*/');
fprintf(fid,'%s\n',' 	/*NOTE:You do not need an else statement when using');
fprintf(fid,'%s\n',' 	mexErrMsgTxt within an if statement. It will never');
fprintf(fid,'%s\n',' 	get to the else statement if mexErrMsgTxt is executed.');
fprintf(fid,'%s\n',' 	(mexErrMsgTxt breaks you out of the MEX-file.)');
fprintf(fid,'%s\n',' 	*/');
fprintf(fid,'%s\n',' 	if (nrhs !=4)');
fprintf(fid,'%s\n',' 		mexErrMsgTxt("Four inputs required.");');
fprintf(fid,'%s\n',' 	if (nlhs !=4)');
fprintf(fid,'%s\n',' 		mexErrMsgTxt("Four output required.");');
fprintf(fid,'%s\n',' ');
fprintf(fid,'%s\n',' ');
fprintf(fid,'%s\n',' 	if (!mxIsDouble(prhs [0 ]) || mxIsComplex(prhs [0 ]) || !mxIsDouble(prhs [1 ]) || mxIsComplex(prhs [1 ]) ){');
fprintf(fid,'%s\n',' 		mexErrMsgTxt("Input matrix type should be ok.");');
fprintf(fid,'%s\n',' 	}');
fprintf(fid,'%s\n',' ');
fprintf(fid,'%s\n',' 	/*Create a pointer to the input matrices.*/');
fprintf(fid,'%s\n',' 	inp1 =mxGetPr(prhs [0 ]);');
fprintf(fid,'%s\n',' 	inp2 =mxGetPr(prhs [1 ]);');
fprintf(fid,'%s\n',' 	inp3 =mxGetPr(prhs [2 ]);');
fprintf(fid,'%s\n',' 	inp4 =mxGetPr(prhs [3 ]);');
fprintf(fid,'%s\n',' ');
fprintf(fid,'%s\n',' 	/*Get the dimensions of the first matrix input y.*/');
fprintf(fid,'%s\n',' 	mrows =mxGetM(prhs [0 ]);');
fprintf(fid,'%s\n',' 	ncols =mxGetN(prhs [0 ]);');
fprintf(fid,'%s\n',' ');
fprintf(fid,'%s\n',' 	/*Set the output pointer to the output matrix.*/');
fprintf(fid,'%s\n',' 	plhs [0 ] = mxCreateDoubleMatrix(mrows,ncols,mxREAL);');
fprintf(fid,'%s\n',' 	plhs [1 ] = mxCreateDoubleMatrix(mrows,ncols,mxREAL);');
fprintf(fid,'%s\n',' 	plhs [2 ] = mxCreateDoubleMatrix(mrows,ncols,mxREAL);');
fprintf(fid,'%s\n',' 	plhs [3 ] = mxCreateDoubleMatrix(mrows,ncols,mxREAL);');
fprintf(fid,'%s\n',' ');
fprintf(fid,'%s\n',' 	/*Create a C pointer to a copy of the output matrix.*/');
fprintf(fid,'%s\n',' 	out1 =mxGetPr(plhs [0 ]);');
fprintf(fid,'%s\n',' 	out2 =mxGetPr(plhs [1 ]);');
fprintf(fid,'%s\n',' 	out3 =mxGetPr(plhs [2 ]);');
fprintf(fid,'%s\n',' 	out4 =mxGetPr(plhs [3 ]);');
fprintf(fid,'%s\n',' ');
fprintf(fid,'%s\n',' 	/*Call the C subroutine.*/');
fprintf(fid,'%s\n',' ');
fprintf(fid,'%s\n',' 	int i, j;');
fprintf(fid,'%s\n',' 	for (i=0; i<mrows; i++) {');
fprintf(fid,'%s\n',' 		for ( j=0; j<ncols; j++) {');
fprintf(fid,'%s\n','            /*use as index [i+mrows*j]');
fprintf(fid,'%s\n','                   minimum taken value is obviously 0');
fprintf(fid,'%s\n','                   maximum value is (mrows-1)+mrows*(ncols-1)=mrows*ncols-1*/');
fprintf(fid,'%s\n',' 			qd_real a(inp1[i+mrows*j], inp2[i+mrows*j], inp3[i+mrows*j], inp4[i+mrows*j]);');
fprintf(fid,'%s\n',' 			qd_real c;	');

%here goes what is specific to this problem
dummy=[' 			c=' a '(a);'];
fprintf(fid,'%s\n',dummy);

fprintf(fid,'%s\n',' ');
fprintf(fid,'%s\n',' 			out1[i+mrows*j] = c.x[0];');
fprintf(fid,'%s\n',' 			out2[i+mrows*j] = c.x[1];');
fprintf(fid,'%s\n',' 			out3[i+mrows*j] = c.x[2];');
fprintf(fid,'%s\n',' 			out4[i+mrows*j] = c.x[3];');
fprintf(fid,'%s\n',' ');
fprintf(fid,'%s\n',' 		}');
fprintf(fid,'%s\n',' 	}');
fprintf(fid,'%s\n',' ');
fprintf(fid,'%s\n',' }');
fclose(fid);
txt=['qd_' a '.cpp'];


%Now the matlab source

fid=fopen(['@qd\' a '.m'],'w');
fprintf(fid,'%s\n',['function s=' a '(a)']);
fprintf(fid,'%s\n',['%' a ': performs ' a '(x) in qd-data type']);
fprintf(fid,'%s\n',['p1=getp1(a);p2=getp2(a);p3=getp3(a);p4=getp4(a);']);
fprintf(fid,'%s\n',['if isreal(p1) & isreal(p2) & isreal(p3) & isreal(p4)']);
fprintf(fid,'%s\n',['  %standard case']);
fprintf(fid,'%s\n',['  [p1,p2,p3,p4]=qd_' a '(getp1(a),getp2(a),getp3(a),getp4(a));']);
fprintf(fid,'%s\n','else');
fprintf(fid,'%s\n','   %complex case');
fprintf(fid,'%s\n','   realp1=real(p1);realp2=real(p2);realp3=real(p3);realp4=real(p4);');
fprintf(fid,'%s\n','   imagp1=imag(p1);imagp2=imag(p2);imagp2=imag(p3);imagp4=imag(p4);');
fprintf(fid,'%s\n','   %put specific code here');
fprintf(fid,'%s\n','end');
fprintf(fid,'%s\n',['s.p1=p1;s.p2=p2;s.p3=p3;s.p4=p4;s=class(s,' setstr(39) 'qd' setstr(39) ');']);
fclose(fid);